using System.Web;
using System.Web.UI;
using System.IO;

namespace AsyncWebDemo
{
    /// <summary>
    /// Based on ScottGu's Implementation Concept
    /// http://weblogs.asp.net/scottgu/archive/2006/10/22/Tip_2F00_Trick_3A00_-Cool-UI-Templating-Technique-to-use-with-ASP.NET-AJAX-for-non_2D00_UpdatePanel-scenarios.aspx
    /// </summary>
    public class ViewManager
    {
        public static string RenderView<D>(string path, D dataToBind)
        {
            Page pageHolder = new Page();
            UserControl viewControl = (UserControl) pageHolder.LoadControl(path);
            if(viewControl is IRenderable<D>)
            {
                if (dataToBind != null)
                {
                    ((IRenderable<D>) viewControl).PopulateData(dataToBind);
                }
            }
            pageHolder.Controls.Add(viewControl);
            StringWriter output = new StringWriter();
            HttpContext.Current.Server.Execute(pageHolder, output, false);

            return output.ToString();
        }
    }

    public interface IRenderable<T>
    {
        void PopulateData(T data);
    }
}
